#include "../../dll/qmx.h"
#include <shellapi.h>
#include <stdio.h>
#include <conio.h> 


#define QMS92SLOT	0

HANDLE SD;                              // Дескриптор системы
WORD QMS15Table[16];
QMX_CC_F CC_Adc[16];
QMX_CONFIG CFG;                         // Конфигурация системы

static unsigned int DataPtr, DataPtrOld, CurrentPtr, LengthDataBuf;
static unsigned short int *Data;
static unsigned int QMS_data[8][32], QMS_iter[8][32], time;


void CheckErr(void);
void quit(void);
void DisplayData(void);


void main(int argc, char* argv[])
{
	char s_wrk[64];
	int mod, ch;;

	printf("Please wait....\r");
	
	// Запустим сервер
	ShellExecuteW(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-p3"), NULL, SW_SHOWNORMAL);
	Sleep(500);

	// Получим дискриптор системы
	SD = 0;
	SD=QMX_CircBufAttach(0);
	if (SD == NULL) {
		printf("ERROR: No QMBox found.");
		quit(); 
	}

	// Проинициализуем систему
	QMX_InitModules(SD, QMX_LOG_NONE, NULL);
	CheckErr();


	// Фиктивный вызов QMX_Prepare - выясним конфигурацию устройства
	// т.е. из каких модулей оно состоит
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	QMX_MOD_SetActive(SD, 0, QMX_OFF);
	
	// Убедимся, что система состоит из нужных модулей
	strncpy_s (s_wrk, CFG.ModName[QMS92SLOT], 5); s_wrk[5] = 0;
	if (!_stricmp(s_wrk, "QMS92"))	printf("2nd Module name OK\n");
	else{ printf("3nd Module Name error\n");	quit();	}


	// Установим частоту сбора данных QMS92 - 4 MГц 
	QMX_QMS90_QMS92_SetRate(SD, QMS92SLOT, 4000000.0, NULL);

	// Выставим на выходы QMS92 число 0х5555
	QMX_QMS90_QMS92_SetOutputs(SD, QMS92SLOT, 0x5555);
	QMX_QMS90_QMS92_OutputEnable(SD, QMS92SLOT, 1);

	// Подготовимся к сбору данных
	QMX_MOD_SetActive(SD, QMS92SLOT, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	
	LengthDataBuf = *CFG.CBInput.buf_size;						// размер кольцевого буфера данных, заполняемого сервером
	Data = (unsigned short int*)CFG.CBInput.buf_start;			// указатель на начало кольцевого буфера данных,
																// заполняемого сервером
	DataPtrOld = 0;
	time = 0;

	// Запустим сбор данных
	QMX_Start(SD);
	CheckErr();

	while (!_kbhit()){											// цикл непрерывного сбора данных
																// (до нажатия кнопки клавиатуры)

		DataPtr = *CFG.CBInput.buf_ptr;							//получим значение указателя на последний 
																// полученный элемент данных						
		for (CurrentPtr = DataPtrOld; CurrentPtr != DataPtr; CurrentPtr += 2) { // цикл считывания всех полученных элементов данных
			
			if(CurrentPtr >= *CFG.CBInput.buf_size)				// Проверки, необходимые
				CurrentPtr = 0;									// чтобы текущий указатель 
			if ((!CurrentPtr)&&(!DataPtr))break;				// не перескочил через границу буфера

			mod = (Data[CurrentPtr] >> 5) & 0x07;				// в четном (младшем) 16-ти битном слове элемента данных содержится 
			ch  = Data[CurrentPtr]  & 0x1f;						// информация о номерах канала (младщие 5-ть бит) и модуля (сл. 3-ри бита).
			
			// Если это модуль QMS92 - не делать накопление, если какой-нибудь модуль АЦП - делать
			if(mod == QMS92SLOT)
				QMS_data[mod][ch] = Data[CurrentPtr+1];			
			else
				QMS_data[mod][ch] += Data[CurrentPtr+1];			// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// информация о величине сигнала измеренного в данном канале данного модуля
																// (в кодах АЦП).
																// в настоящем примере измерения интегрируются в соответствующей ([модуль][канал])
																// ячейке массива накопления. В реальной программе пользователя измерения могут
																// перемещаться в поканальные массивы без усреднения, для дальнейшей обработки или
																// записи в выходные файлы.
			QMS_iter[mod][ch]++;								// счетчик количества суммирований для данного канала
	
		}

		DataPtrOld = DataPtr;						// запоминание предыдущего указателя на последний полученный
													// элемент данных

		time++;										// счетчик количества 100 мс интервалов
		if (time >=5){								// если накопление длится более 0.5 с,
			DisplayData();							// произвести отображение результатов измерений
			time = 0;								// обнуление счетчика количества 100 мс интервалов
		}

		Sleep(20);									// Ожидание следующей порции данных от сервера 
													// В реальной программе в этом месте вместо Sleep может производится
													// обработка полученных данных и их запись в файл

 }

	quit();											// выход из программы
}



// Выход из программы
void quit(void){
	
	printf("\n\n Please wait....\r");
	QMX_Stop(SD, QMX_STOP_ALL);			// Остановим систему
	QMX_MOD_SetStartMode(SD, 0xFF, QMX_START_MODE_MANUAL); 									

	QMX_CircBufDetach(SD);              // Освободим виртуальный слот USB
										// Остановим сервер
	ShellExecute(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-s0"), NULL, SW_SHOWNORMAL);
	printf("\n\n");
	ExitProcess(0);
}


// Проверка на ошибки
void CheckErr(void) {
char tmp_str[1024];

if (QMX_GetLastError(SD, tmp_str, sizeof(tmp_str))==QMX_OK){ return;}
else  {	printf("%s\n", tmp_str);	quit();}
}



// Отображение данных
void DisplayData(void){

	// Сначала отображаются данные с модуля QMS92, потом - с QMS15
	
	double d_wrk;
//	unsigned short qms92_data;

	// Данные с QMS92
	printf("%X   \r", QMS_data[QMS92SLOT][0]);
}
